﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using InvokeSolutions.Xlsx.Reader.LowLayer.DOM;
using InvokeSolutions.Xlsx.Reader;

namespace WindowsFormsApplicationXlsx
{
    public partial class FormReadXlsx : Form
    {
        public FormReadXlsx()
        {
            InitializeComponent();
        }

        Sheet[] result = null;

        private void buttonBrowse_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();

            if (ofd.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return;

// read xlsx and get array of sheets
            result = XlsxReader.Read(ofd.FileName);

            comboBoxSheet.DisplayMember = "Name";
            comboBoxSheet.ValueMember = "Name";
            comboBoxSheet.DataSource = result;

        }

        private void comboBoxSheet_SelectedIndexChanged(object sender, EventArgs e)
        {
// find sheet by name
            var sheet = result.FirstOrDefault(s=>s.Name == comboBoxSheet.Text);

            StringBuilder sb = new StringBuilder();

// enum all rows
            for (int i = 0; i < sheet.Height; i++)
            {
// all cells
                for (int j = 0; j < sheet.Width; j++)
// convert different types to string
                    sb.AppendFormat("{0}\t", sheet.Values[i, j]);
             
                sb.AppendLine();
            }

            textBoxOutput.Text = sb.ToString();
        }
    }
}
